/*
 * IncFile1.h
 *
 * Created: 20.01.2014 12:21:57
 *  Author: Alex
 */ 


#ifndef LTC2486_functions_H_
#define LTC2486_functions_H_

#define EN 13			// Enable. EN=0: Keep previous. EN=1: Use Config data
#define SGL 12			// SGL=1: Single ended mode. One of four channels is selected as positive input
#define ODD 11			// Channel Determination.
#define A2 10			// Channel Determination.
#define A1 9			// Channel Determination.
#define A0 8			// Channel Determination.
#define EN2 7			// Enable bit for conversion config. EN=1: Use sent data; EN2=0: Next conversion using previously selected converter config
#define IM 6			// IM=1: Select temperature sensor. Next conversion performed on TS. Ignore SPD,GS2,GS1,GS0
#define FA 5			// Set rejection Frequency 
#define FB 4			// Set rejection Frequency
#define SPD 3			// Conversion Speed Bit: SPD =0: 1x output rate, auto-calibration enabled (~150ms/sample); SPD =1: 2x output rate, auto-calibration disabled
#define GS2 2			// Gain Selection
#define GS1 1			// Gain Selection
#define GS0 0			// Gain Selection

#include <avr/io.h>
#include <stdbool.h>

uint32_t LTC2486_SPI_get_value (uint16_t config);
uint16_t LTC2486_create_config (uint8_t channel, bool doublespeed, bool temp, uint8_t gain);
uint16_t LTC2486_extract_value (uint32_t data);
uint16_t LTC2486_extract_temp (uint32_t data);
bool LTC2486_conversion_complete (void);


#endif /* LTC2486_functions_H_ */