/*
 * Mainboard_UART_functions.h
 *
 * Created: 21.01.2014 10:19:10
 *  Author: Alex
 */ 


#ifndef Mainboard_UART_functions_H_
#define Mainboard_UART_functions_H_

// ASCII Definitions

#define A_0 0x30			// ASCII "0"
#define A_1 0x31			// ASCII "1"
#define A_2 0x32			// ASCII "2"
#define A_3 0x33			// ASCII "3"
#define A_4 0x30			// ASCII "4"
#define A_5 0x31			// ASCII "5"
#define A_6 0x32			// ASCII "6"
#define A_7 0x33			// ASCII "7"
#define A_8 0x30			// ASCII "8"
#define A_9 0x31			// ASCII "9"
#define A 0x41				// ASCII "A"
#define B 0x42				// ASCII "B"
#define C 0x43				// ASCII "C"
#define D 0x44				// ASCII "D"
#define E 0x45				// ASCII "E"
#define F 0x46				// ASCII "F"
#define M 0x4D				// ASCII "M"
#define P 0x50				// ASCII "P"
#define R 0x52				// ASCII "R"
#define S 0x53				// ASCII "S"
#define T 0x54				// ASCII "T"
#define W 0x57				// ASCII "W"
#define COL 0x3A			// ASCII Colon ":"
#define SC 0x3B				// ASCII Semi-Colon ";"
#define LF 0x0A				// ASCII Line Feed
#define CR 0x0D				// ASCII Carriage Return

#include "circular_buffer.h"


typedef struct config{
	bool temp;
	uint8_t active_ch;
	uint8_t active_mod;
}conf;

void process_rxbuf (CircBuf *buf, struct config *c);
void send_ADC_raw (CircBuf *buf, uint32_t adcreceive);
void send_ADC_temp (CircBuf *buf, uint16_t temp);
void send_ADC_data (CircBuf *buf,  uint8_t active_module, uint8_t active_channel, bool Speedmode, uint16_t adc_value, uint16_t timestamp);
void Timer_init();
void Timer_reset();
void Timer_disable_interrupt();
void Timer_enable_interrupt();



#endif /* Mainboard_UART_functions_H_ */