/*
 * SPI_functions.c
 *
 * Created: 20.01.2014 10:07:51
 *  Author: Alex
 */ 

#include "SPI_functions.h"


void SPI_init() {
	// SPI Clock: 20MHz/8 = 2.5MHz
	PRR &= ~(1<<PRSPI);								// Enable SPI Module (Power Reduction SPI Flag = 0)
	SPCR = (1<<MSTR)|(1<<SPR0)|(1<<SPE);			// Config SPI Control Register: Define as Master, transmit MSB first (DORD:0), fosc/8; SPI Enable
	SPSR |= (1<<SPI2X);								// SPI Double Speed bit (for fosc/8)
}

void SPI_activate_slave() {
	PORTC &= ~(1<<PINC0);
}

void SPI_deactivate_slave() {
	PORTC |= (1<<PINC0);
}

void SPI_write_byte(uint8_t byte) {
	SPDR = byte;
}

uint8_t SPI_read_byte() {
	uint8_t buf = 0;
	buf = SPDR;
	return buf;
}