
#include "circular_buffer.h"


void buffer_init (CircBuf *buf)					// Initialization of circular buffer values
{
	buf->read_ptr=0;
	buf->write_ptr=0;
}

void circbuf_add(CircBuf *buf, uint8_t byte)	// Write byte into buffer, increment fillcounter and write pointer
{
	buf->data[buf->write_ptr] = byte;
	
	if (buf->write_ptr >= buffer_size-1){
		buf->write_ptr = 0;
	}
	else{
		buf->write_ptr = buf->write_ptr + 1;
	}
}

uint8_t circbuf_get(CircBuf *buf)				// Read byte out of buffer, decrement fillcounter, increment read ptr
{
	uint8_t returnval =0;
	
	if  (buf->read_ptr == buf->write_ptr){
		return 0;
	}
	else 
	{
		returnval= buf->data[buf->read_ptr];
		
		if (buf->read_ptr >= buffer_size-1){
			buf->read_ptr = 0;
		}
		else{
			buf->read_ptr = buf->read_ptr + 1;
		}
		return returnval;
	}

}

bool circbuf_isfull (CircBuf *buf)
{
	if (buf->write_ptr + 1 == buf->read_ptr || buf->read_ptr == 0 && buf->write_ptr + 1 == buffer_size)
	return true;
	else return false;
}

bool circbuf_isempty (CircBuf *buf)
{
	if (buf->read_ptr == buf->write_ptr) return true;
	else return false;
}