#ifndef CIRCBUF_H_
#define CIRCBUF_H_

#include <avr/io.h>
#include <stdlib.h>
#include <stdbool.h>

#define buffer_size 128			

typedef struct circular_buffer {
	uint8_t data[buffer_size];
	uint8_t read_ptr;			// points to last input data
	uint8_t write_ptr;			// always points to empty field
	}CircBuf;

void buffer_init (CircBuf *buf);
uint8_t circbuf_get(CircBuf *buf);
void circbuf_add(CircBuf *buf, uint8_t byte);
bool circbuf_isempty(CircBuf  *buf);
bool circbuf_isfull(CircBuf *buf);
void circbuf_clear(CircBuf *buf);

#endif /*CIRCBUF_H_*/
